# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class BlueprintapiblueprintsblueprintIdValidationMessages(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'resource_name': 'str',
        'path': 'str',
        'message': 'str',
        'type': 'str',
        'metadata': 'dict(str, str)'
    }

    attribute_map = {
        'resource_name': 'resourceName',
        'path': 'path',
        'message': 'message',
        'type': 'type',
        'metadata': 'metadata'
    }

    def __init__(self, resource_name=None, path=None, message=None, type=None, metadata=None):  # noqa: E501
        """BlueprintapiblueprintsblueprintIdValidationMessages - a model defined in Swagger"""  # noqa: E501
        self._resource_name = None
        self._path = None
        self._message = None
        self._type = None
        self._metadata = None
        self.discriminator = None
        if resource_name is not None:
            self.resource_name = resource_name
        if path is not None:
            self.path = path
        if message is not None:
            self.message = message
        if type is not None:
            self.type = type
        if metadata is not None:
            self.metadata = metadata

    @property
    def resource_name(self):
        """Gets the resource_name of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501

        Resource name  # noqa: E501

        :return: The resource_name of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :rtype: str
        """
        return self._resource_name

    @resource_name.setter
    def resource_name(self, resource_name):
        """Sets the resource_name of this BlueprintapiblueprintsblueprintIdValidationMessages.

        Resource name  # noqa: E501

        :param resource_name: The resource_name of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :type: str
        """

        self._resource_name = resource_name

    @property
    def path(self):
        """Gets the path of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501

        Validation path  # noqa: E501

        :return: The path of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this BlueprintapiblueprintsblueprintIdValidationMessages.

        Validation path  # noqa: E501

        :param path: The path of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :type: str
        """

        self._path = path

    @property
    def message(self):
        """Gets the message of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501

        Validation message  # noqa: E501

        :return: The message of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this BlueprintapiblueprintsblueprintIdValidationMessages.

        Validation message  # noqa: E501

        :param message: The message of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def type(self):
        """Gets the type of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501

        Message type  # noqa: E501

        :return: The type of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this BlueprintapiblueprintsblueprintIdValidationMessages.

        Message type  # noqa: E501

        :param type: The type of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :type: str
        """
        allowed_values = ["INFO", "WARNING", "ERROR"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def metadata(self):
        """Gets the metadata of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501

        Metadata  # noqa: E501

        :return: The metadata of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this BlueprintapiblueprintsblueprintIdValidationMessages.

        Metadata  # noqa: E501

        :param metadata: The metadata of this BlueprintapiblueprintsblueprintIdValidationMessages.  # noqa: E501
        :type: dict(str, str)
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BlueprintapiblueprintsblueprintIdValidationMessages, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BlueprintapiblueprintsblueprintIdValidationMessages):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
